package explorviz.live_trace_processing.filter.reduction.summarization;

import java.util.List;

import explorviz.live_trace_processing.record.event.AbstractBeforeEventRecord;
import explorviz.live_trace_processing.record.event.AbstractEventRecord;
import explorviz.live_trace_processing.record.trace.Trace;

class TracePatternSummarizationBuffer {
	private Trace accumulator;
	private final long bufferCreatedTimestamp;

	public TracePatternSummarizationBuffer(final long bufferCreatedTimestamp) {
		this.bufferCreatedTimestamp = bufferCreatedTimestamp;
	}

	public long getBufferCreatedTimestamp() {
		return bufferCreatedTimestamp;
	}

	public Trace getAggregatedTrace() {
		return accumulator;
	}

	public void insertTrace(final Trace trace) {
		if (accumulator == null) {
			accumulator = trace;
		} else {
			final List<AbstractEventRecord> aggregatedRecords = accumulator.getTraceEvents();
			final List<AbstractEventRecord> records = trace.getTraceEvents();

			for (int i = 0; i < aggregatedRecords.size(); i++) {
				final AbstractEventRecord event = aggregatedRecords.get(i);
				if (event instanceof AbstractBeforeEventRecord) {
					aggregatedRecords.get(i).getRuntime().merge(records.get(i).getRuntime());
				}
			}
		}
	}
}